  <master src="../help-master">

    <property name="context">{index "Help"} Customize</property>
    <property name="show_button">1</property>
    <property name="title">Help - Customize</property>

	<h1>Customize <%=[ad_system_name]%></h1>

	<h2>
      <a name="accessibility-options">Accessibility options</a>
    </h2>

	<h3>To switch from standard mode to high-contrast mode</h3>
	<p>At the top left corner of any <%=[ad_system_name]%> page, click on &quot;Accessibility&quot; link then choose the &quot;High contrast&quot; option in the &quot;Change Contrast&quot; section.</p>

	<h3>To switch from high-contrast mode to standard mode</h3>
	<p>At the top left corner of any <%=[ad_system_name]%> page, click on &quot;Accessibility&quot; then choose the &quot;Default colors&quot; option in the &quot;Change Contrast&quot; section.</p>

	<h2>
      <a name="customize-pages-home">Rename, hide, add or remove pages in Home</a>
    </h2>

	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      This page allows you to customize all the pages under the &quot;Home&quot; section: &quot;My Space&quot;, &quot;My Calendar&quot;, and &quot;My Files&quot;. You can as well rename those 3 pages and add new pages. 
    </p>
    <p>
      All pages under the &quot;Home&quot; section are built upon modules (<abbr title="Also Known As">A.K.A.</abbr> portlets). The &quot;Customize Layout&quot; page allows you to move the module location within one page and between different pages.
    </p>

	<h3>To rename a page</h3>
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below. To the right of the page title, there is a field with the current page name. Write the new name in this field.
    </p>
	<ul>
      <li>Click on &quot;Rename Page&quot; button.</li>
    </ul> 
	<p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page
    </p>

	<h3>To hide a page</h3>
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below. On the same level to the right of the page title, there is a field with the current page name. Under this field is a &quot;Hide this page&quot; button
    </p>
	<ul>
      <li>Click on &quot;Hide this page button&quot;.</li>
    </ul> 
	<p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page.
    </p>

	<h3>To add a page</h3>
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      All page titles appear with the list of modules that compose them below. 
    </p>
	<ul>
      <li>Under &quot;Create a new page&quot;, type new page title in the blank field</li>
      <li>Click on &quot;Add page&quot;</li>
    </ul>
	<p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page
    </p>

	<h2>
      <a name="customize-modules-home">Move, add or remove modules in Home</a>
    </h2>

	<h3>To move modules within a page</h3> 
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below. The modules are separated in 2 columns that represent the current 2-column layout on the actual page.  For each module there is a &quot;Remove&quot; button and - depending of the module current location- up to 4 buttons which correspond to: move left, move right, move up, move down. Each of them is represented by an arrow with the corresponding direction. Clicking on any of those buttons applies the changes immediately.
    </p>

	<ul>
      <li>Click on the direction button to move the module where you want to put it.</li>
      <li>The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page</li>
    </ul>
	
    <h3>To move a module to another page</h3>
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below. The modules are separated in 2 columns that represent the current 2-column layout on the actual page.  For each module there is a remove button and - depending of the module current location- up to 4 buttons: move left, move right, move up, and move down. Below the module name, there is a &quot;Move to page&quot; button followed by a drop down menu.
    </p>
	<ul>
      <li>For the module selected, select its new location in the dropdown menu and click on &quot;Move to Page&quot; button.</li>
    </ul> 
	<p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the revert button at the very bottom of the &quot;Customize Layout&quot; page.
    </p>

	<h3>To add a module to a page</h3> 
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below, separated in 2 columns. At the bottom of each column, under Unused Portlets, a dropdown menu lists all the modules that are not currently used in any pages of the Home section. Note that you can only add a module to a page if it is not used in any other page.
    </p>
	<ul>
      <li>Under &quot;Unused Portlets&quot;, select in the dropdown menu the module that you want to add.</li>
    </ul> 
    <p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page.
    </p>

	<h3>To remove modules</h3> 
	<ul>
      <li>Go to &quot;Control Panel&quot;</li>
      <li>In the &quot;Preferences&quot; area, click on &quot;Customize Layout&quot;</li>
    </ul>
	<p>
      The page title appears with the list of modules that compose it below, separated in 2 columns.  For each module there is a remove button and - depending of the module current location- there are up to 4 buttons: move left, move right, move up, move down. 
    </p>
	<ul>
      <li>Click on the remove button next to the module you want to remove</li>
    </ul>
	<p>
      The change is automatically reflected on the site. To change it back to the default set up, click on the &quot;Revert&quot; button at the very bottom of the &quot;Customize Layout&quot; page
    </p>
